var EventDispatcher;
EventDispatcher = require('./EventDispatcher');
exports.init = function(model, dom, view) {
  var events, get;
  get = model.get;
  events = model.__events = new EventDispatcher({
    onTrigger: function(path, listener, value, options) {
      var id, method, oldPath, property, viewFunc;
      oldPath = listener[0], id = listener[1], method = listener[2], property = listener[3], viewFunc = listener[4];
      if (!(oldPath === path || get(oldPath) === get(path))) {
        return false;
      }
      if (options && options.method) {
        method = options.method;
      }
      if (viewFunc) {
        value = view.get(viewFunc, value);
      }
      return dom.update(id, method, property, value);
    },
    onBind: function(path, listener) {
      return listener.unshift(path);
    }
  });
  model.on('set', function(_arg) {
    var path, value;
    path = _arg[0], value = _arg[1];
    return events.trigger(path, value);
  });
  model.on('push', function(_arg) {
    var path, value;
    path = _arg[0], value = _arg[1];
    return events.trigger(path, value, {
      method: 'appendHtml'
    });
  });
  return model;
};